--- old/usr/src/test/os-tests/tests/secflags/secflags_core.sh	Mon Oct 21 21:31:32 2019
+++ new/usr/src/test/os-tests/tests/secflags/secflags_core.sh	Mon Oct 21 21:31:32 2019
@@ -13,6 +13,7 @@
 
 #
 # Copyright 2015, Richard Lowe.
+# Copyright 2019 Joyent, Inc.
 #
 
 mkdir /tmp/secflags-test.$$
@@ -20,16 +21,26 @@
 
 /usr/bin/psecflags -s aslr -e sleep 100000 &
 pid=$!
-coreadm -p core $pid # We need to be able to reliably find the core
+# Make sure we generate a kernel core we can find
+coreadm -p core $pid
+enabled=$(/usr/bin/svcprop -p config_params/process_enabled coreadm)
+coreadm_restore=""
+if [[ "$enabled" = "false" ]]; then
+    coreadm_restore="/usr/bin/coreadm -d process"
+    coreadm -e process
+fi
 
 cleanup() {
     kill $pid >/dev/null 2>&1
     cd /
     rm -fr /tmp/secflags-test.$$
+
+    $coreadm_restore
 }
 
 trap cleanup EXIT
 
+sleep 1
 ## gcore-produced core
 gcore $pid >/dev/null
 
@@ -42,6 +53,7 @@
 /usr/bin/psecflags core.${pid} | grep -v '[LU]:' > gcore-output.$$
 
 if ! diff -u gcore-expected.$$ gcore-output.$$; then
+    $coreadm_restore
     exit 1;
 fi
 
@@ -48,6 +60,7 @@
 ## kernel-produced core
 kill -SEGV $pid
 wait $pid >/dev/null 2>&1
+$coreadm_restore
 
 cat > core-expected.$$ <<EOF
 core 'core' of $pid:	sleep 100000
